hpp-constraints: hpp::constraints::RelativeCom Class Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::constraints::RelativeCom Class Reference
Constraints

`#include <hpp/constraints/relative-com.hh>`

Inheritance diagram for hpp::constraints::RelativeCom:
[legend]
Collaboration diagram for hpp::constraints::RelativeCom:
[legend]

## Public Member Functions
virtual | ~RelativeCom ()
| RelativeCom (const DevicePtr_t &robot, const CenterOfMassComputationPtr_t &comc, const JointPtr_t &joint, const vector3_t reference, std::vector< bool > mask, const std::string &name)
virtual std::ostream & | print (std::ostream &o) const
| Display object in a stream.
Public Member Functions inherited from hpp::constraints::DifferentiableFunction
virtual | ~DifferentiableFunction ()
LiegroupElement | operator() (vectorIn_t argument) const
void | value (LiegroupElementRef result, vectorIn_t argument) const
void | jacobian (matrixOut_t jacobian, vectorIn_t argument) const
const ArrayXb & | activeParameters () const
const ArrayXb & | activeDerivativeParameters () const
size_type | inputSize () const
| Get dimension of input vector.
size_type | inputDerivativeSize () const
LiegroupSpacePtr_t | outputSpace () const
| Get output space.
size_type | outputSize () const
| Get dimension of output vector.
size_type | outputDerivativeSize () const
| Get dimension of output derivative vector.
const std::string & | name () const
| Get function name.
std::string | context () const
void | context (const std::string &c)
void | finiteDifferenceForward (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
void | finiteDifferenceCentral (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
bool | operator== (DifferentiableFunction const &other) const
bool | operator!= (DifferentiableFunction const &b) const
virtual std::pair< JointConstPtr_t, JointConstPtr_t > | dependsOnRelPoseBetween (DeviceConstPtr_t) const

## Static Public Member Functions
static EIGEN_MAKE_ALIGNED_OPERATOR_NEW RelativeComPtr_t | create (const DevicePtr_t &robot, const JointPtr_t &joint, const vector3_t reference, std::vector< bool > mask=std::vector< bool >(3, true))
| Return a shared pointer to a new instance.
static RelativeComPtr_t | create (const std::string &name, const DevicePtr_t &robot, const JointPtr_t &joint, const vector3_t reference, std::vector< bool > mask=std::vector< bool >(3, true))
static RelativeComPtr_t | create (const DevicePtr_t &robot, const CenterOfMassComputationPtr_t &comc, const JointPtr_t &joint, const vector3_t reference, std::vector< bool > mask=std::vector< bool >(3, true))
static RelativeComPtr_t | create (const std::string &name, const DevicePtr_t &robot, const CenterOfMassComputationPtr_t &comc, const JointPtr_t &joint, const vector3_t reference, std::vector< bool > mask=std::vector< bool >(3, true))
Static Public Member Functions inherited from hpp::constraints::DifferentiableFunction
static DifferentiableFunctionPtr_t | extract (DifferentiableFunctionPtr_t original, interval_t interval)

## Protected Member Functions
virtual void | impl_compute (LiegroupElementRef result, ConfigurationIn_t argument) const
virtual void | impl_jacobian (matrixOut_t jacobian, ConfigurationIn_t arg) const
bool | isEqual (const DifferentiableFunction &other) const
Protected Member Functions inherited from hpp::constraints::DifferentiableFunction
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, size_type sizeOutput, std::string name=std::string())
| Concrete class constructor should call this constructor.
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, const LiegroupSpacePtr_t &outputSpace, std::string name=std::string())
| Concrete class constructor should call this constructor.
virtual void | impl_compute (LiegroupElementRef result, vectorIn_t argument) const =0
| User implementation of function evaluation.
virtual void | impl_jacobian (matrixOut_t jacobian, vectorIn_t arg) const =0
| DifferentiableFunction ()

## Additional Inherited Members
Protected Attributes inherited from hpp::constraints::DifferentiableFunction
size_type | inputSize_
| Dimension of input vector.
size_type | inputDerivativeSize_
| Dimension of input derivative.
LiegroupSpacePtr_t | outputSpace_
| Dimension of output vector.
ArrayXb | activeParameters_
ArrayXb | activeDerivativeParameters_

## Detailed Description

Constraint on the relative position of the center of mass

The value of the function is defined as the position of the center of mass in the reference frame of a joint.

where

- is the position of the joint,
- is the position of the center of mass,
- is the desired position of the center of mass expressed in joint frame.

## Constructor & Destructor Documentation

## ◆ ~RelativeCom()

virtual hpp::constraints::RelativeCom::~RelativeCom | ( |  | ) |
| inline virtual

## ◆ RelativeCom()

hpp::constraints::RelativeCom::RelativeCom | ( | const DevicePtr_t & | robot,
|  | const CenterOfMassComputationPtr_t & | comc,
|  | const JointPtr_t & | joint,
|  | const vector3_t | reference,
|  | std::vector< bool > | mask,
|  | const std::string & | name )

## Member Function Documentation

## ◆ create() [1/4]

static RelativeComPtr_t hpp::constraints::RelativeCom::create | ( | const DevicePtr_t & | robot,
|  | const CenterOfMassComputationPtr_t & | comc,
|  | const JointPtr_t & | joint,
|  | const vector3_t | reference,
|  | std::vector< bool > | mask = std::vector< bool >(3, true) )
| static

## ◆ create() [2/4]

static EIGEN_MAKE_ALIGNED_OPERATOR_NEW RelativeComPtr_t hpp::constraints::RelativeCom::create | ( | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint,
|  | const vector3_t | reference,
|  | std::vector< bool > | mask = std::vector<bool>(3, true) )
| inline static

Return a shared pointer to a new instance.

## ◆ create() [3/4]

static RelativeComPtr_t hpp::constraints::RelativeCom::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const CenterOfMassComputationPtr_t & | comc,
|  | const JointPtr_t & | joint,
|  | const vector3_t | reference,
|  | std::vector< bool > | mask = std::vector< bool >(3, true) )
| static

## ◆ create() [4/4]

static RelativeComPtr_t hpp::constraints::RelativeCom::create | ( | const std::string & | name,
|  | const DevicePtr_t & | robot,
|  | const JointPtr_t & | joint,
|  | const vector3_t | reference,
|  | std::vector< bool > | mask = std::vector< bool >(3, true) )
| static

## ◆ impl_compute()

virtual void hpp::constraints::RelativeCom::impl_compute | ( | LiegroupElementRef | result,
|  | ConfigurationIn_t | argument ) const
| protected virtual

Compute value of error

Parameters

  argument | configuration of the robot,

Return values

  result | error vector

## ◆ impl_jacobian()

virtual void hpp::constraints::RelativeCom::impl_jacobian | ( | matrixOut_t | jacobian,
|  | ConfigurationIn_t | arg ) const
| protected virtual

## ◆ isEqual()

bool hpp::constraints::RelativeCom::isEqual | ( | const DifferentiableFunction & | other | ) | const
| inline protected virtual

Reimplemented from hpp::constraints::DifferentiableFunction.

## ◆ print()

virtual std::ostream & hpp::constraints::RelativeCom::print | ( | std::ostream & | o | ) | const
| virtual

Display object in a stream.

Reimplemented from hpp::constraints::DifferentiableFunction.

The documentation for this class was generated from the following file:

- include/hpp/constraints/relative-com.hh